<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: Introduction</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Introduction </div>  </div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#autotoc_md1">Overview</a></li>
<li class="level1"><a href="#autotoc_md2">Compilation</a><ul><li class="level2"><a href="#autotoc_md3">Prerequisites</a></li>
<li class="level2"><a href="#autotoc_md4">Cloning the source</a></li>
<li class="level2"><a href="#autotoc_md5">Manual compilation</a></li>
<li class="level2"><a href="#autotoc_md6">Compilation using cmake</a></li>
</ul>
</li>
<li class="level1"><a href="#autotoc_md7">Examples</a><ul><li class="level2"><a href="#autotoc_md8">Hello world</a></li>
<li class="level2"><a href="#autotoc_md9">Vectors as lists</a></li>
<li class="level2"><a href="#autotoc_md10">Maps</a></li>
<li class="level2"><a href="#autotoc_md11">Numbers</a></li>
<li class="level2"><a href="#autotoc_md12">Other objects</a></li>
<li class="level2"><a href="#autotoc_md13">Redirecting output</a></li>
<li class="level2"><a href="#autotoc_md14">Example binaries</a></li>
</ul>
</li>
<li class="level1"><a href="#autotoc_md15">Using C++20 concepts</a></li>
<li class="level1"><a href="#autotoc_md16">Licence</a></li>
</ul>
</div>
<div class="textblock"><h1><a class="anchor" id="autotoc_md1"></a>
Overview</h1>
<p>This project provides a print function for C++ that automatically formats vectors, maps, etc.; similar to the print function in other programming languages (e.g., python3). Implemented using <a href="https://en.cppreference.com/w/cpp/language/constraints">C++20 concepts</a>.</p>
<p>This project was motivated by an interest in exploring the new cocncepts in C++20, as well as the desire to have a convenient print function for vectors and maps, with nice formatting.</p>
<p>The <a class="el" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a" title="Prints any object.">print()</a> function can be used like </p><div class="fragment"><div class="line">std::vector vector01 {1, 2, 3, 4};</div>
<div class="line">std::vector vector02 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A short list:&quot;</span>, vector01);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list:&quot;</span>, vector02);</div>
<div class="line"> </div>
<div class="line">std::map&lt;int, std::string&gt; map01 {{1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map:&quot;</span>, map01);</div>
</div><!-- fragment --><div class="fragment"><div class="line">A short list: [1, 2, 3, 4]</div>
<div class="line">A longer list: [1, 2, 3, 4, ..., 10]</div>
<div class="line">A map: [(1, A), (2, B), (3, C)];</div>
</div><!-- fragment --><p>Various formatting options are possible, e.g., </p><div class="fragment"><div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Text&quot;</span>, 1024, 3141.5, vector01, prt::Options {</div>
<div class="line">        .seperator = <span class="stringliteral">&quot; / &quot;</span>,</div>
<div class="line">        .end =  <span class="stringliteral">&quot; $\n&quot;</span>,</div>
<div class="line">        .file = std::cerr,</div>
<div class="line">        .flush = <span class="keyword">true</span>,</div>
<div class="line">        .color = prt::Red,</div>
<div class="line">        .weight = prt::Bold,</div>
<div class="line">        .integerFormat = prt::Hexadecimal,</div>
<div class="line">        .floatFormat = prt::Scientific,</div>
<div class="line">        .floatPrecision = 3,</div>
<div class="line">        .listStyle = prt::ListStyle {</div>
<div class="line">            .delimiters = {<span class="stringliteral">&quot;[&quot;</span>, <span class="stringliteral">&quot;]&quot;</span>},</div>
<div class="line">            .seperator = <span class="stringliteral">&quot;; &quot;</span></div>
<div class="line">            }</div>
<div class="line">        });</div>
</div><!-- fragment --><p>which will print </p><div class="fragment"><div class="line">Text / 0x400 / 3.142e+03 / [0x1; 0x2; 0x3; 0x4; 0x5] $</div>
</div><!-- fragment --><p>in bold red.</p>
<p>See the documentation of the <code>PrintOptions</code> class and the examples below for details.</p>
<h1><a class="anchor" id="autotoc_md2"></a>
Compilation</h1>
<p>The following steps can be used to compile the library and the example binaries under Ubuntu. For other operating systems the process should be similar.</p>
<h2><a class="anchor" id="autotoc_md3"></a>
Prerequisites</h2>
<p>This software uses some new features of the C++20 standard, such as <a href="https://en.cppreference.com/w/cpp/language/constraints">concepts</a>. It is therefore necessary to use a very recent compiler.</p>
<p>For g++ at least <em>version 10</em> is required. On Ubuntu it can be installed with (needs 'universe') </p><div class="fragment"><div class="line">sudo apt install g++-10</div>
</div><!-- fragment --><p>Compilation was also successfully tested with <code>clang++-10</code>.</p>
<p>Using a recent version of <code>cmake</code> for building the binary is recommended.</p>
<h2><a class="anchor" id="autotoc_md4"></a>
Cloning the source</h2>
<p>Clone the repository to anywhere on your hard drive. </p><div class="fragment"><div class="line">cd &lt;PATH_TO_SOURCE&gt;</div>
<div class="line">git clone https://gitlab.com/martin.b.krauss/cpp20-print.git</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md5"></a>
Manual compilation</h2>
<p>A simple program using <a class="el" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a" title="Prints any object.">print()</a>, such as </p><div class="fragment"><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print_8h.html">print.h</a>&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">int</span>, <span class="keywordtype">char</span>**) {</div>
<div class="line">    <span class="keyword">using namespace </span>cpp20print;</div>
<div class="line">    <span class="keyword">using</span> printing::print;</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hello world!&quot;</span>);</div>
<div class="line">}</div>
</div><!-- fragment --><p>can be saved as <code>simple.cpp</code> in the same parent directory as the soure and be compiled with </p><div class="fragment"><div class="line">g++-10 -o simple simple.cpp cpp20-print/src/terminal.cpp -I cpp20-print/include -std=c++20</div>
</div><!-- fragment --><p>For compilation in other directories adjust all file paths accordingly.</p>
<p>Run the binary with </p><div class="fragment"><div class="line">./simple</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md6"></a>
Compilation using cmake</h2>
<p>Create a build directory outside the source directory and then configure it with cmake. </p><div class="fragment"><div class="line">cd &lt;PATH_TO_BUILD&gt;</div>
<div class="line">mkdir build</div>
<div class="line">cd build</div>
<div class="line">cmake &lt;PATH_TO_SOURCE&gt;/cpp20-print</div>
</div><!-- fragment --><p>Since the latest compiler version (install if necessary) might not be the system's default compiler, you might need to modify the last line to </p><div class="fragment"><div class="line">cmake &lt;PATH_TO_SOURCE&gt;/cpp20-print -D CMAKE_CXX_COMPILER=g++-10</div>
</div><!-- fragment --><p>or if you prefer to use clang </p><div class="fragment"><div class="line">cmake &lt;PATH_TO_SOURCE&gt;/cpp20-print -D CMAKE_CXX_COMPILER=clang++-10</div>
</div><!-- fragment --><p>After cmake has configured the build it should be sufficient to simply run </p><div class="fragment"><div class="line">make</div>
</div><!-- fragment --><p>This will create a file <code>libcpp20print.a</code> in the build directory. To compile a program against the library </p><div class="fragment"><div class="line">g++-10 -o simple2 simple.cpp -lcpp20print -L &lt;PATH_TO_BUILD&gt; -I &lt;PATH_TO_SOURCE&gt;/cpp20-print/include -std=c++20</div>
</div><!-- fragment --><p>Alternatively add a <code>cmake</code> target at the end of the file <code>CMakeLists.txt</code> </p><div class="fragment"><div class="line">add_executable(</div>
<div class="line">    simple3</div>
<div class="line">    &lt;PATH_TO_SIMPLE&gt;/simple.cpp</div>
<div class="line">    )</div>
<div class="line"> </div>
<div class="line">target_link_libraries(</div>
<div class="line">    simple3</div>
<div class="line">    PRIVATE cpp20print</div>
<div class="line">    )</div>
</div><!-- fragment --><p>and run <code>make</code>.</p>
<p>To build a shared library use </p><div class="fragment"><div class="line">cmake &lt;PATH_TO_SOURCE&gt;/cpp20-print -D CMAKE_CXX_COMPILER=g++-10 -D BUILD_SHARED_LIBS=ON</div>
<div class="line">make</div>
</div><!-- fragment --><p>Which creates <code>libcpp20print.so</code> in the build directory. Compile the binary against the library as above. If the shared library is not found try running the binaries with </p><div class="fragment"><div class="line">export LD_LIBRARY_PATH=&quot;&lt;PATH_TO_BUILD&gt;/build&quot;; ./simple2</div>
<div class="line">export LD_LIBRARY_PATH=&quot;&lt;PATH_TO_BUILD&gt;/build&quot;; ./simple3</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md7"></a>
Examples</h1>
<h2><a class="anchor" id="autotoc_md8"></a>
Hello world</h2>
<p>A simple program using <a class="el" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a" title="Prints any object.">print()</a></p>
<div class="fragment"><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print_8h.html">print.h</a>&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">int</span>, <span class="keywordtype">char</span>**) {</div>
<div class="line">    <span class="keyword">using namespace </span>cpp20print;</div>
<div class="line">    <span class="keyword">using</span> printing::print;</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hello world!&quot;</span>);</div>
<div class="line">}</div>
</div><!-- fragment --><p>For testing save this simple program as simple.cpp in the same parent directory as the soure and compile with </p><div class="fragment"><div class="line">g++-10 -o simple simple.cpp cpp20-print/src/terminal.cpp -I cpp20-print/include -std=c++20</div>
</div><!-- fragment --><p>Run the binary with </p><div class="fragment"><div class="line">./simple</div>
</div><!-- fragment --><p>We can set print options like this </p><div class="fragment"><div class="line">printing::PrintOptions printOptions {</div>
<div class="line">    .color = printing::PrintOptions::Color::Blue</div>
<div class="line">    };</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hello world!&quot;</span>, printOptions);</div>
</div><!-- fragment --><p>We can also enable some shortcuts for more convenience</p>
<div class="fragment"><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print_8h.html">print.h</a>&quot;</span></div>
<div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print__shortcuts_8h.html">print_shortcuts.h</a>&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">int</span>, <span class="keywordtype">char</span>**) {</div>
<div class="line">    <span class="keyword">using namespace </span>cpp20print;</div>
<div class="line">    <span class="keyword">using</span> printing::print;</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">namespace </span>prt = printing::shortcuts;</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hello world!&quot;</span>, prt::Options {.color = prt::Blue});</div>
<div class="line"> </div>
<div class="line">}</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md9"></a>
Vectors as lists</h2>
<p>The print function will automatically format vectors as lists </p><div class="fragment"><div class="line">std::vector vector01 {1, 2, 3, 4};</div>
<div class="line">std::vector vector02 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A short list:&quot;</span>, vector01);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list:&quot;</span>, vector02);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list with more elements shown:&quot;</span>, vector02, prt::Options{</div>
<div class="line">        .listStyle = {.maxElementsPrinted = 7}</div>
<div class="line">        });</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list with all elements shown:&quot;</span>, vector02, prt::Options{</div>
<div class="line">        .listStyle = {.expand = <span class="keyword">true</span>}</div>
<div class="line">        });</div>
</div><!-- fragment --><div class="fragment"><div class="line">A short list: [1, 2, 3, 4]</div>
<div class="line">A longer list: [1, 2, 3, 4, ..., 10]</div>
<div class="line">A longer list with more elements shown: [1, 2, 3, 4, 5, 6, ..., 10]</div>
<div class="line">A longer list with all elements shown: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]</div>
</div><!-- fragment --><p>Since we use templates and concepts every object can be printed as a list, if it's class provides a forward iterator </p><div class="fragment"><div class="line">std::set&lt;int&gt; set01 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line">std::deque&lt;int&gt; queue01 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Printing a set using the power of templates with concepts:&quot;</span>, set01);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;It&#39;s the same for printing a std::deque:&quot;</span>, queue01);</div>
</div><!-- fragment --><div class="fragment"><div class="line">Printing a set using the power of templates with concepts: [1, 2, 3, 4, ..., 10]</div>
<div class="line">It&#39;s the same for printing a std::deque: [1, 2, 3, 4, ..., 10]</div>
</div><!-- fragment --><p>Note that, e.g., a std::queue is not iterable and therefore we cannot print it as a list. This is a limitation of the class, not the print function. By design there is no way to access its elements without modifying the queue. <br  />
</p>
<h2><a class="anchor" id="autotoc_md10"></a>
Maps</h2>
<p>We can also print maps </p><div class="fragment"><div class="line">std::map&lt;int, std::string&gt; map01 {</div>
<div class="line">    {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map:&quot;</span>, map01);</div>
<div class="line"> </div>
<div class="line">std::map&lt;int, std::string&gt; map02 {</div>
<div class="line">    {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}, {4, <span class="stringliteral">&quot;D&quot;</span>}, {5, <span class="stringliteral">&quot;E&quot;</span>}, {6, <span class="stringliteral">&quot;F&quot;</span>}</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map with more items:&quot;</span>, map02);</div>
<div class="line"> </div>
<div class="line">std::unordered_map&lt;int, std::string&gt; map03 {</div>
<div class="line">    {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}, {4, <span class="stringliteral">&quot;D&quot;</span>}, {5, <span class="stringliteral">&quot;E&quot;</span>}, {6, <span class="stringliteral">&quot;F&quot;</span>}</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;An unordered map with more items:&quot;</span>, map03);</div>
</div><!-- fragment --><div class="fragment"><div class="line">A map: [(1, A), (2, B), (3, C)]</div>
<div class="line">A map with more items: [(1, A), (2, B), (3, C), (4, D), ..., (6, F)]</div>
<div class="line">An unordered map with more items: [(6, F), (5, E), (4, D), (3, C), (2, B), ...]</div>
</div><!-- fragment --><p>We can also change their style </p><div class="fragment"><div class="line">prt::ListStyle dictionaryStyle {</div>
<div class="line">    .delimiters = {<span class="stringliteral">&quot;{&quot;</span>, <span class="stringliteral">&quot;}&quot;</span>},</div>
<div class="line">    .seperator = <span class="stringliteral">&quot;; &quot;</span></div>
<div class="line">};</div>
<div class="line">prt::ListStyle dictionaryItemStyle {</div>
<div class="line">        .delimiters = {<span class="stringliteral">&quot;&quot;</span>,<span class="stringliteral">&quot;&quot;</span>},</div>
<div class="line">        .seperator = {<span class="stringliteral">&quot; : &quot;</span>}</div>
<div class="line">        };</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map with a different style:&quot;</span>, map01, prt::Options{</div>
<div class="line">        .listStyle = dictionaryStyle,</div>
<div class="line">        .pairStyle = dictionaryItemStyle</div>
<div class="line">        });</div>
</div><!-- fragment --><div class="fragment"><div class="line">A map with a different style: {1 : A; 2 : B; 3 : C}</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md11"></a>
Numbers</h2>
<p>There are also options to change the formatting of integers and floating point numbers </p><div class="fragment"><div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Decimal numbers:&quot;</span>,       1024, 0xff, 020);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hexadecimal numbers:&quot;</span>,   1024, 0xff, 020, prt::Options {</div>
<div class="line">        .integerFormat = prt::Hexadecimal</div>
<div class="line">        });</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Octal numbers:&quot;</span>,         1024, 0xff, 020, prt::Options {</div>
<div class="line">        .integerFormat = prt::Octal</div>
<div class="line">        });</div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Floating point numbers:&quot;</span>, 1.0, 3141.5, 0.01);</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, scientific notation:&quot;</span>,</div>
<div class="line">        1.0, 3141.5, 0.01,</div>
<div class="line">        prt::Options {.floatFormat = prt::Scientific}</div>
<div class="line">        );</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, fixed width notation:&quot;</span>,</div>
<div class="line">        1.0, 3141.5, 0.01,</div>
<div class="line">        prt::Options {.floatFormat = prt::Fixed}</div>
<div class="line">        );</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, scientific notation (higher precision):&quot;</span>,</div>
<div class="line">        1.0, 3141.5, 0.01,</div>
<div class="line">        prt::Options {.floatFormat = prt::Scientific, .floatPrecision = 5}</div>
<div class="line">        );</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, fixed width notation (higher precision):&quot;</span>,</div>
<div class="line">        1.0, 3141.5, 0.01,</div>
<div class="line">        prt::Options {.floatFormat = prt::Fixed, .floatPrecision = 5}</div>
<div class="line">        );</div>
</div><!-- fragment --><div class="fragment"><div class="line">Decimal numbers: 1024 255 16</div>
<div class="line">Hexadecimal numbers: 0x400 0xff 0x10</div>
<div class="line">Octal numbers: 0o2000 0o377 0o20</div>
<div class="line">Floating point numbers: 1.00 3141.50 0.01</div>
<div class="line">Floating point numbers, scientific notation: 1.00e+00 3.14e+03 1.00e-02</div>
<div class="line">Floating point numbers, fixed width notation: 1.00 3141.50 0.01</div>
<div class="line">Floating point numbers, scientific notation (higher precision): 1.00000e+00 3.14150e+03 1.00000e-02</div>
<div class="line">Floating point numbers, fixed width notation (higher precision): 1.00000 3141.50000 0.01000</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md12"></a>
Other objects</h2>
<p>For objects that have a friend ostream operator&lt;&lt; or a string() member function, these will be used. If both are defined the opertor takes precedence.</p>
<p>If an object is not printable it will be replaced by </p><div class="fragment"><div class="line">&lt;NOT_PRINTABLE&gt;</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md13"></a>
Redirecting output</h2>
<p>The output of print can be redirected </p><div class="fragment"><div class="line"><span class="comment">// print to std::cerr</span></div>
<div class="line"> </div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is an error message.&quot;</span>, prt::Options {</div>
<div class="line">        .file = std::cerr,</div>
<div class="line">        .color = prt::Error</div>
<div class="line">        });</div>
<div class="line"> </div>
<div class="line"><span class="comment">// print to file</span></div>
<div class="line">std::filesystem::path filePath {<span class="stringliteral">&quot;test.txt&quot;</span>};</div>
<div class="line">std::ofstream testFile {filePath};</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is printed to a file.&quot;</span>, prt::Options {.file = testFile});</div>
<div class="line"><a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Printed output to file:&quot;</span>, filePath);</div>
</div><!-- fragment --><p>This will output (colors omitted) </p><div class="fragment"><div class="line">This is an error message.</div>
<div class="line">Printed output to file: &quot;test.txt&quot;</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md14"></a>
Example binaries</h2>
<p>After compiling the source with cmake, the the binaries <code>example</code> and <code>example_ostream</code> will have been created in the build directory. They can be run with </p><div class="fragment"><div class="line">./example</div>
<div class="line">./example_ostream</div>
</div><!-- fragment --><p>The first program will demonstrate the use of the <a class="el" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a" title="Prints any object.">print()</a> function in the terminal and output also a file <code>test.txt</code>. Its source is </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;queue&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;deque&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;unordered_map&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print_8h.html">print.h</a>&quot;</span></div>
<div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print__options_8h.html">print_options.h</a>&quot;</span></div>
<div class="line"><span class="preprocessor">#include &quot;<a class="code" href="print__shortcuts_8h.html">print_shortcuts.h</a>&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &quot;example_helper.h&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main(<span class="keywordtype">int</span>, <span class="keywordtype">char</span>**) {</div>
<div class="line">    <span class="keyword">using namespace </span>cpp20print;</div>
<div class="line">    <span class="keyword">using</span> printing::print;</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;*************************************&quot;</span>);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;* Demonstration of print() features *&quot;</span>);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;*************************************&quot;</span>);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// simple print</span></div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hello world!&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// printing strings</span></div>
<div class="line">    std::string string01 {<span class="stringliteral">&quot;This is a string.&quot;</span>};</div>
<div class="line">    std::string string02 {<span class="stringliteral">&quot;This is another string.&quot;</span>};</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Print several strings:&quot;</span>, string01, string02);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print options</span></div>
<div class="line">    <span class="keyword">namespace </span>prt = printing::shortcuts;</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Now we can, e.g., use prt::Green instead of </span></div>
<div class="line">    <span class="comment">// printing::PrintOptions::Color::Green</span></div>
<div class="line">    </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is green text.&quot;</span>, prt::Options {.color = prt::Green});</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is yellow text.&quot;</span>, prt::Options {.color = prt::Yellow});</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is bold cyan text.&quot;</span>, prt::Options {</div>
<div class="line">            .color = prt::Cyan,</div>
<div class="line">            .weight = prt::Bold</div>
<div class="line">            });</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Print several strings, without spaces: &quot;</span>, </div>
<div class="line">            string01, </div>
<div class="line">            string02, </div>
<div class="line">            prt::Options {.seperator = <span class="stringliteral">&quot;&quot;</span>}</div>
<div class="line">            );</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Continue on same line:&quot;</span>, prt::Options {.end = <span class="stringliteral">&quot; &quot;</span>});</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(string01, prt::Options {.end = <span class="stringliteral">&quot; &quot;</span>});</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(string02);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print lists -- vectors</span></div>
<div class="line"> </div>
<div class="line">    std::vector vector01 {1, 2, 3, 4};</div>
<div class="line">    std::vector vector02 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A short list:&quot;</span>, vector01);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list:&quot;</span>, vector02);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list with more elements shown:&quot;</span>, vector02, prt::Options{</div>
<div class="line">            .listStyle = {.maxElementsPrinted = 7}</div>
<div class="line">            });</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A longer list with all elements shown:&quot;</span>, vector02, prt::Options{</div>
<div class="line">            .listStyle = {.expand = <span class="keyword">true</span>}</div>
<div class="line">            });</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// We haven&#39;t explicitly defined a function for printing a std::set.</span></div>
<div class="line">    <span class="comment">// But due to the power of templates with concepts it is recognized as a</span></div>
<div class="line">    <span class="comment">// list-like object, since we can iterate over it.</span></div>
<div class="line">    <span class="comment">//</span></div>
<div class="line">    <span class="comment">// NOTE: Some containers like std::stack or std::queue are not iterable by</span></div>
<div class="line">    <span class="comment">// design. Therefore we can&#39;t print their elements. This is a limitation of</span></div>
<div class="line">    <span class="comment">// the class not the print function.</span></div>
<div class="line">    </div>
<div class="line">    std::set&lt;int&gt; set01 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line">    std::deque&lt;int&gt; queue01 {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};</div>
<div class="line">    std::queue&lt;int&gt; queue02 {queue01};</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Printing a set using the power of templates with concepts:&quot;</span>, set01);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;It&#39;s the same for printing a std::deque:&quot;</span>, queue01);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;We can&#39;t print a std::queue since it is not iterable:&quot;</span>, queue02);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print lists -- maps</span></div>
<div class="line"> </div>
<div class="line">    std::map&lt;int, std::string&gt; map01 {</div>
<div class="line">        {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}</div>
<div class="line">    };</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map:&quot;</span>, map01);</div>
<div class="line"> </div>
<div class="line">    std::map&lt;int, std::string&gt; map02 {</div>
<div class="line">        {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}, {4, <span class="stringliteral">&quot;D&quot;</span>}, {5, <span class="stringliteral">&quot;E&quot;</span>}, {6, <span class="stringliteral">&quot;F&quot;</span>}</div>
<div class="line">    };</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map with more items:&quot;</span>, map02);</div>
<div class="line"> </div>
<div class="line">    std::unordered_map&lt;int, std::string&gt; map03 {</div>
<div class="line">        {1, <span class="stringliteral">&quot;A&quot;</span>}, {2, <span class="stringliteral">&quot;B&quot;</span>}, {3, <span class="stringliteral">&quot;C&quot;</span>}, {4, <span class="stringliteral">&quot;D&quot;</span>}, {5, <span class="stringliteral">&quot;E&quot;</span>}, {6, <span class="stringliteral">&quot;F&quot;</span>}</div>
<div class="line">    };</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;An unordered map with more items:&quot;</span>, map03);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print lists with different style</span></div>
<div class="line"> </div>
<div class="line">    prt::ListStyle dictionaryStyle {</div>
<div class="line">        .delimiters = {<span class="stringliteral">&quot;{&quot;</span>, <span class="stringliteral">&quot;}&quot;</span>},</div>
<div class="line">        .seperator = <span class="stringliteral">&quot;; &quot;</span></div>
<div class="line">    };</div>
<div class="line">    prt::ListStyle dictionaryItemStyle {</div>
<div class="line">            .delimiters = {<span class="stringliteral">&quot;&quot;</span>,<span class="stringliteral">&quot;&quot;</span>},</div>
<div class="line">            .seperator = {<span class="stringliteral">&quot; : &quot;</span>}</div>
<div class="line">            };</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A map with a different style:&quot;</span>, map01, prt::Options{</div>
<div class="line">            .listStyle = dictionaryStyle,</div>
<div class="line">            .pairStyle = dictionaryItemStyle</div>
<div class="line">            });</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print numbers</span></div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Decimal numbers:&quot;</span>,       1024, 0xff, 020);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Hexadecimal numbers:&quot;</span>,   1024, 0xff, 020, prt::Options {</div>
<div class="line">            .integerFormat = prt::Hexadecimal</div>
<div class="line">            });</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Octal numbers:&quot;</span>,         1024, 0xff, 020, prt::Options {</div>
<div class="line">            .integerFormat = prt::Octal</div>
<div class="line">            });</div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Floating point numbers:&quot;</span>, 1.0, 3141.5, 0.01);</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, scientific notation:&quot;</span>, </div>
<div class="line">            1.0, 3141.5, 0.01, </div>
<div class="line">            prt::Options {.floatFormat = prt::Scientific}</div>
<div class="line">            );</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, fixed width notation:&quot;</span>, </div>
<div class="line">            1.0, 3141.5, 0.01, </div>
<div class="line">            prt::Options {.floatFormat = prt::Fixed}</div>
<div class="line">            );</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, scientific notation (higher precision):&quot;</span>, </div>
<div class="line">            1.0, 3141.5, 0.01, </div>
<div class="line">            prt::Options {.floatFormat = prt::Scientific, .floatPrecision = 5}</div>
<div class="line">            );</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(  <span class="stringliteral">&quot;Floating point numbers, fixed width notation (higher precision):&quot;</span>, </div>
<div class="line">            1.0, 3141.5, 0.01, </div>
<div class="line">            prt::Options {.floatFormat = prt::Fixed, .floatPrecision = 5}</div>
<div class="line">            );</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print arbitrary objects using a fallback</span></div>
<div class="line"> </div>
<div class="line">    <a class="code" href="structcpp20print_1_1example_1_1NotPrintable.html">example::NotPrintable</a> notPrintable {};</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Not printable objects are replaced:&quot;</span>, notPrintable);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print objects with a string() method</span></div>
<div class="line">    </div>
<div class="line">    <a class="code" href="classcpp20print_1_1example_1_1HasStringMethod.html">example::HasStringMethod</a> hasStringMethod;</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;A class with a string() method:&quot;</span>, hasStringMethod);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print objects with a custom ostream operator&lt;&lt;</span></div>
<div class="line">    </div>
<div class="line">    <a class="code" href="classcpp20print_1_1example_1_1HasCustomOstreamOperator.html">example::HasCustomOstreamOperator</a> hasCustomOstreamOperator;</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;An ostream operator&lt;&lt; takes precedence:&quot;</span>, hasCustomOstreamOperator);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print to std::cerr</span></div>
<div class="line"> </div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is an error message.&quot;</span>, prt::Options {</div>
<div class="line">            .file = std::cerr,</div>
<div class="line">            .color = prt::Error</div>
<div class="line">            });</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// print to file</span></div>
<div class="line">    std::filesystem::path filePath {<span class="stringliteral">&quot;test.txt&quot;</span>};</div>
<div class="line">    std::ofstream testFile {filePath};</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;This is printed to a file.&quot;</span>, prt::Options {.file = testFile});</div>
<div class="line">    <a class="code" href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">print</a>(<span class="stringliteral">&quot;Printed output to file:&quot;</span>, filePath);</div>
<div class="line">}</div>
</div><!-- fragment --><p>Its output should look similar to the following (colors omitted): </p><div class="fragment"><div class="line">*************************************</div>
<div class="line">* Demonstration of print() features *</div>
<div class="line">*************************************</div>
<div class="line"> </div>
<div class="line">Hello world!</div>
<div class="line">Print several strings: This is a string. This is another string.</div>
<div class="line">This is green text.</div>
<div class="line">This is yellow text.</div>
<div class="line">This is bold cyan text.</div>
<div class="line">Print several strings, without spaces: This is a string.This is another string.</div>
<div class="line">Continue on same line: This is a string. This is another string.</div>
<div class="line">A short list: [1, 2, 3, 4]</div>
<div class="line">A longer list: [1, 2, 3, 4, ..., 10]</div>
<div class="line">A longer list with more elements shown: [1, 2, 3, 4, 5, 6, ..., 10]</div>
<div class="line">A longer list with all elements shown: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]</div>
<div class="line">Printing a set using the power of templates with concepts: [1, 2, 3, 4, ..., 10]</div>
<div class="line">It&#39;s the same for printing a std::deque: [1, 2, 3, 4, ..., 10]</div>
<div class="line">We can&#39;t print a std::queue since it is not iterable: &lt;NOT_PRINTABLE&gt;</div>
<div class="line">A map: [(1, A), (2, B), (3, C)]</div>
<div class="line">A map with more items: [(1, A), (2, B), (3, C), (4, D), ..., (6, F)]</div>
<div class="line">An unordered map with more items: [(6, F), (5, E), (4, D), (3, C), (2, B), ...]</div>
<div class="line">A map with a different style: {1 : A; 2 : B; 3 : C}</div>
<div class="line">Decimal numbers: 1024 255 16</div>
<div class="line">Hexadecimal numbers: 0x400 0xff 0x10</div>
<div class="line">Octal numbers: 0o2000 0o377 0o20</div>
<div class="line">Floating point numbers: 1.00 3141.50 0.01</div>
<div class="line">Floating point numbers, scientific notation: 1.00e+00 3.14e+03 1.00e-02</div>
<div class="line">Floating point numbers, fixed width notation: 1.00 3141.50 0.01</div>
<div class="line">Floating point numbers, scientific notation (higher precision): 1.00000e+00 3.14150e+03 1.00000e-02</div>
<div class="line">Floating point numbers, fixed width notation (higher precision): 1.00000 3141.50000 0.01000</div>
<div class="line">Not printable objects are replaced: &lt;NOT_PRINTABLE&gt;</div>
<div class="line">A class with a string() method: This is the output of the string() method.</div>
<div class="line">An ostream operator&lt;&lt; takes precedence: This is the output of the custom ostream operator&lt;&lt;.</div>
<div class="line">This is an error message.</div>
<div class="line">Printed output to file: &quot;test.txt&quot;</div>
</div><!-- fragment --><p>The second example demonstrates the use of print features with an ostream operator&lt;&lt;.</p>
<h1><a class="anchor" id="autotoc_md15"></a>
Using C++20 concepts</h1>
<p>The concepts that have been introduced in C++20 provide a form a static duck typing. We can use their power to implement a printing function that can accept various arguments and print them to the screen depending on their properties. We can use this feature for instance to print objects that can be iterated over as lists.</p>
<p>In <a class="el" href="print__concepts_8h.html">print_concepts.h</a> we define several concepts, such as </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line">concept <a class="code" href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">Printable</a> = <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a>(T t) {</div>
<div class="line">    {std::cout &lt;&lt; t} -&gt; std::same_as&lt;std::ostream&amp;&gt;;</div>
<div class="line">};</div>
<div class="line"> </div>
<div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line">concept <a class="code" href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">UnicodeString</a> =</div>
<div class="line">    std::same_as&lt;T, std::u8string&gt; ||</div>
<div class="line">    std::same_as&lt;T, std::u16string&gt; ||</div>
<div class="line">    std::same_as&lt;T, std::u32string&gt;;</div>
<div class="line"> </div>
<div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line">concept <a class="code" href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">PrintableList</a> = <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T a) {</div>
<div class="line">        {a.begin()} -&gt; std::forward_iterator;</div>
<div class="line">    };</div>
<div class="line"> </div>
<div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line">concept <a class="code" href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">PrintableListNoString</a> = </div>
<div class="line">        concepts::PrintableList&lt;T&gt; &amp;&amp;</div>
<div class="line">        concepts::Printable&lt;T&gt; ==  <span class="keyword">false</span> &amp;&amp;</div>
<div class="line">        concepts::UnicodeString&lt;T&gt; == <span class="keyword">false</span>;</div>
<div class="line"> </div>
<div class="line">}</div>
</div><!-- fragment --><p>which defines the concept of list like types. All we need is that the object has a begin() method that returns a <code>std::forward_iterator</code>. This is the case, e.g., for <code>std::vector</code> or <code>std::map</code>. Since strings also have forward iterators, but shouldn't be printed as lists of letters we define a concept <code>PrintableListNoString</code>.</p>
<p>The main print(...) function will call the print_element(...) function for each argument. It is defined as follows </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div>
<div class="line"><span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(</div>
<div class="line">        std::ostream&amp; out,</div>
<div class="line">        <span class="keyword">const</span> PrintOptions&amp; options,</div>
<div class="line">        <span class="keyword">const</span> T&amp; t</div>
<div class="line">        ) </div>
<div class="line">{ </div>
<div class="line">    <a class="code" href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">print_atom</a>(out, options, t);</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keyword">template</span>&lt;Pr<span class="keywordtype">int</span>ableListNoString T&gt;</div>
<div class="line"><span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(</div>
<div class="line">        std::ostream&amp; out,</div>
<div class="line">        <span class="keyword">const</span> PrintOptions&amp; options,</div>
<div class="line">        <span class="keyword">const</span> T&amp; t</div>
<div class="line">        ) </div>
<div class="line">{ </div>
<div class="line">    <a class="code" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a>(out, t, options);</div>
<div class="line">}</div>
</div><!-- fragment --><p>The overload will be statically resolved during compilation. If <code>T</code> is list-like, e.g., a <code>std::vector</code> the second overload will be called. In all other cases the generic template matches and the first function will be called.</p>
<p>The print_list(...) function looks like </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ableList L&gt;</div>
<div class="line"><span class="keywordtype">void</span> <a class="code" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a>(</div>
<div class="line">        std::ostream&amp; out, </div>
<div class="line">        <span class="keyword">const</span> L&amp; list, </div>
<div class="line">        <span class="keyword">const</span> PrintOptions&amp; options = {}</div>
<div class="line">        )</div>
<div class="line">{</div>
<div class="line">    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; listStyle = options.listStyle;</div>
<div class="line">    out &lt;&lt; listStyle.delimiters.first;</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span> childOptions {options};</div>
<div class="line">    <span class="keywordflow">if</span> (options.listStyle.subListStyle != <span class="keyword">nullptr</span>) {</div>
<div class="line">        childOptions.listStyle = *options.listStyle.subListStyle;</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    <span class="keywordtype">size_t</span> count {0};</div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; element: list) {</div>
<div class="line">        ++count;</div>
<div class="line">        <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, childOptions, element);</div>
<div class="line"> </div>
<div class="line">        <span class="keywordflow">if</span> (count != list.size()) {</div>
<div class="line">            out &lt;&lt; listStyle.seperator;</div>
<div class="line">            <span class="keywordflow">if</span> (    count == listStyle.maxElementsPrinted &amp;&amp;</div>
<div class="line">                    !listStyle.expand</div>
<div class="line">                    ) </div>
<div class="line">            {</div>
<div class="line">                    out &lt;&lt; <span class="stringliteral">&quot;...&quot;</span>;</div>
<div class="line">                <span class="keywordflow">break</span>;</div>
<div class="line">            }</div>
<div class="line">        }</div>
<div class="line">        </div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    out &lt;&lt; listStyle.delimiters.second;</div>
<div class="line">}</div>
</div><!-- fragment --><p>With the concept </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; </div>
<div class="line">concept <a class="code" href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">HasLastElement</a> = <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T a) {</div>
<div class="line">        {a.end()} -&gt; std::bidirectional_iterator;</div>
<div class="line">    };</div>
</div><!-- fragment --><p>we can add an overload also to print_list </p><div class="fragment"><div class="line"><span class="keyword">template</span>&lt;concepts::Pr<span class="keywordtype">int</span>ableList L&gt; <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> concepts::HasLastElement&lt;L&gt;</div>
<div class="line"><span class="keywordtype">void</span> <a class="code" href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">print_list</a>(</div>
<div class="line">        std::ostream&amp; out, </div>
<div class="line">        <span class="keyword">const</span> L&amp; list, </div>
<div class="line">        <span class="keyword">const</span> PrintOptions&amp; options = {}</div>
<div class="line">        )</div>
<div class="line">{</div>
<div class="line">    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; listStyle = options.listStyle;</div>
<div class="line">    out &lt;&lt; listStyle.delimiters.first;</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">auto</span> childOptions {options};</div>
<div class="line">    <span class="keywordflow">if</span> (options.listStyle.subListStyle != <span class="keyword">nullptr</span>) {</div>
<div class="line">        childOptions.listStyle = *options.listStyle.subListStyle;</div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">const</span> <span class="keyword">auto</span>&amp; end = *(--list.end());</div>
<div class="line">    <span class="keywordtype">size_t</span> count {0};</div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; element: list) {</div>
<div class="line">        ++count;</div>
<div class="line">        <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, options, element);</div>
<div class="line"> </div>
<div class="line">        <span class="keywordflow">if</span> (&amp;element != &amp;end) {</div>
<div class="line">            out &lt;&lt; listStyle.seperator;</div>
<div class="line">            <span class="keywordflow">if</span> (    count == listStyle.maxElementsPrinted - 1 &amp;&amp; </div>
<div class="line">                    !listStyle.expand</div>
<div class="line">                    ) </div>
<div class="line">            {</div>
<div class="line">                <span class="keywordflow">if</span> (list.size() &gt; listStyle.maxElementsPrinted) </div>
<div class="line">                    out &lt;&lt; <span class="stringliteral">&quot;...&quot;</span> &lt;&lt; listStyle.seperator;</div>
<div class="line">                <a class="code" href="print_8h.html#afe9466890a34c5498386a55281bf30a7">print_element</a>(out, childOptions, end);</div>
<div class="line">                <span class="keywordflow">break</span>;</div>
<div class="line">            }</div>
<div class="line">        }</div>
<div class="line">        </div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    out &lt;&lt; listStyle.delimiters.second;</div>
<div class="line">    </div>
<div class="line">}</div>
</div><!-- fragment --><p>The latter overload will be called, e.g., for a <code>std::vector</code>, the former, e.g., for a <code>std::unordered_map</code>. See the examples above for their different behaviour.</p>
<p>See the documentation of <a class="el" href="print_8h.html">print.h</a>, <a class="el" href="print__concepts_8h.html">print_concepts.h</a>, and <a class="el" href="print__atom_8h.html">print_atom.h</a> for more examples.</p>
<h1><a class="anchor" id="autotoc_md16"></a>
Licence</h1>
<p>Copyright (c) 2021 Martin B. Krauss.</p>
<p>Licensed under the MIT LICENSE.</p>
<p>See the file 'LICENSE' that should be distributed with this software or can be found at '<a href="https://gitlab.com/martin.b.krauss/cpp20-print'">https://gitlab.com/martin.b.krauss/cpp20-print'</a> for details. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<div class="ttc" id="aclasscpp20print_1_1example_1_1HasStringMethod_html"><div class="ttname"><a href="classcpp20print_1_1example_1_1HasStringMethod.html">cpp20print::example::HasStringMethod</a></div><div class="ttdef"><b>Definition:</b> example_helper.h:15</div></div>
<div class="ttc" id="aclasscpp20print_1_1example_1_1HasCustomOstreamOperator_html"><div class="ttname"><a href="classcpp20print_1_1example_1_1HasCustomOstreamOperator.html">cpp20print::example::HasCustomOstreamOperator</a></div><div class="ttdef"><b>Definition:</b> example_helper.h:20</div></div>
<div class="ttc" id="aprint__atom_8h_html_ad47012d4b2f909cec110fa350eae7192"><div class="ttname"><a href="print__atom_8h.html#ad47012d4b2f909cec110fa350eae7192">cpp20print::printing::detail::print_atom</a></div><div class="ttdeci">void print_atom(std::ostream &amp;out, const PrintOptions &amp;, const T &amp;)</div><div class="ttdoc">Prints single object. Fallback for all other objects.</div><div class="ttdef"><b>Definition:</b> print_atom.h:22</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a0dc42e855b90ebe331eadf76da1ed24a"><div class="ttname"><a href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">cpp20print::concepts::PrintableList</a></div><div class="ttdeci">concept PrintableList</div><div class="ttdoc">Objects that can be printed as a list.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:30</div></div>
<div class="ttc" id="aprint_8h_html_afe9466890a34c5498386a55281bf30a7"><div class="ttname"><a href="print_8h.html#afe9466890a34c5498386a55281bf30a7">cpp20print::printing::detail::print_element</a></div><div class="ttdeci">void print_element(std::ostream &amp;out, const PrintOptions &amp;options, const T &amp;t)</div><div class="ttdoc">Prints a single object. Default for objects that are not lists (&quot;atoms&quot;).</div><div class="ttdef"><b>Definition:</b> print.h:23</div></div>
<div class="ttc" id="astructcpp20print_1_1example_1_1NotPrintable_html"><div class="ttname"><a href="structcpp20print_1_1example_1_1NotPrintable.html">cpp20print::example::NotPrintable</a></div><div class="ttdef"><b>Definition:</b> example_helper.h:13</div></div>
<div class="ttc" id="aprint__atom_8h_html_a08a0df05930aa51f1c30e856b5e6ff99"><div class="ttname"><a href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">cpp20print::printing::detail::requires</a></div><div class="ttdeci">requires(concepts::PrintableInteger&lt; T &gt;==false) &amp;&amp;(concepts</div><div class="ttdoc">Prints single object. Use default operator&lt;&lt; if defined.</div><div class="ttdef"><b>Definition:</b> print_atom.h:35</div></div>
<div class="ttc" id="aprint_8h_html"><div class="ttname"><a href="print_8h.html">print.h</a></div></div>
<div class="ttc" id="aprint__concepts_8h_html_acfda3fade5c38f41048c0dd4e65f8fe0"><div class="ttname"><a href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">cpp20print::concepts::HasLastElement</a></div><div class="ttdeci">concept HasLastElement</div><div class="ttdoc">Lists that have a defined last element.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:39</div></div>
<div class="ttc" id="aprint__list_8h_html_aecd33a9a08711f90f308fc69f05aa827"><div class="ttname"><a href="print__list_8h.html#aecd33a9a08711f90f308fc69f05aa827">cpp20print::printing::detail::print_list</a></div><div class="ttdeci">requires concepts::HasLastElement&lt; L &gt; void print_list(std::ostream &amp;out, const L &amp;list, const PrintOptions &amp;options={})</div><div class="ttdoc">Prints an ordered list.</div><div class="ttdef"><b>Definition:</b> print_list.h:58</div></div>
<div class="ttc" id="aprint__list_8h_html_adc7f764bf8b8bbba1e7c57153ac51413"><div class="ttname"><a href="print__list_8h.html#adc7f764bf8b8bbba1e7c57153ac51413">cpp20print::printing::PrintableListNoString</a></div><div class="ttdeci">concept PrintableListNoString</div><div class="ttdoc">A list that is not a string or unicode string.</div><div class="ttdef"><b>Definition:</b> print_list.h:20</div></div>
<div class="ttc" id="aprint__concepts_8h_html_a7be037f25d3aca35ec2ab298e4fe0e4e"><div class="ttname"><a href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">cpp20print::concepts::Printable</a></div><div class="ttdeci">concept Printable</div><div class="ttdoc">Objects that can be printed to a std::ostream.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:22</div></div>
<div class="ttc" id="aprint_8h_html_aeee5a1be79dd7c9cb87c7f6aa842a89a"><div class="ttname"><a href="print_8h.html#aeee5a1be79dd7c9cb87c7f6aa842a89a">cpp20print::printing::print</a></div><div class="ttdeci">void print(const Args &amp;...args)</div><div class="ttdoc">Prints any object.</div><div class="ttdef"><b>Definition:</b> print.h:117</div></div>
<div class="ttc" id="aprint__shortcuts_8h_html"><div class="ttname"><a href="print__shortcuts_8h.html">print_shortcuts.h</a></div></div>
<div class="ttc" id="aprint__options_8h_html"><div class="ttname"><a href="print__options_8h.html">print_options.h</a></div></div>
<div class="ttc" id="aprint__concepts_8h_html_a44633268b78ebac99b47279732528c32"><div class="ttname"><a href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">cpp20print::concepts::UnicodeString</a></div><div class="ttdeci">concept UnicodeString</div><div class="ttdoc">Unicode strings.</div><div class="ttdef"><b>Definition:</b> print_concepts.h:69</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
